import numpy as np
from astropy import table
from . import PACKAGE_PATH


# the main algorithm
def flip_image(img: np.ndarray) -> np.ndarray:
    """ flip an input image

    This function uses an awesome algorithm to flip an input image.

    Parameters
    ----------
    img:
        the input image

    Returns
    -------
    img_flipped: np.ndarray
        the flipped image

    """
    try:
        assert img.ndim == 2
        img_flipped = img[::-1, ::-1]
        return img_flipped
    except AssertionError:
        raise AssertionError("The input image is {}D not 2D!".format(img.ndim))


# a demo on how to read test image
def read_test_image():
    """ read test image """
    fp_img = PACKAGE_PATH + "/data/test_image.txt"
    print("reading file {} ...".format(fp_img))
    return np.loadtxt(fp_img, dtype=int)
